#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <vector>
#include <algorithm>
using namespace std;

const int NMAX = 100000 + 7;

vector <int> pos[10];
char s[NMAX];
int n;

int positionForMaximum(int j,int k,int p,int right) {
	return max(j,k+p-right);
}

int G(int left,int right,int k,int l,int previousMax) {
	int maxNumber = 0;
	int li,ri;
	for (int j=previousMax-1;j>=0;j--){
		vector <int>::iterator it = lower_bound(pos[j].begin(),pos[j].end(),left);
		if (it == pos[j].end()) continue;
		if (*it <= right) {
			li = it - pos[j].begin();
			ri = upper_bound(pos[j].begin(),pos[j].end(),right) - pos[j].begin() - 1;
			maxNumber = j;
			break;
		}
	}
	int C = ri-li+1;
	int t1 = positionForMaximum(1,k,pos[maxNumber][li],right);
	if (t1 > l){
		return G(left,pos[maxNumber][li]-1,t1-1,l,maxNumber);
	}
	if (t1 == l){
		return maxNumber;
	}
	int tC = positionForMaximum(C,k,pos[maxNumber][ri],right);
	if (tC < l){
		return G(pos[maxNumber][ri] + 1,right,k-tC,l-tC,maxNumber);
	}
	if (tC == l){
		return maxNumber;
	}
	int j,mi;
	int tJ,tJ_1;
	int leftMaximum = li;
	li++;
	while (li <= ri){
		mi = (li+ri)/2;
		j = mi - leftMaximum + 1;
		tJ = positionForMaximum(j,k,pos[maxNumber][mi],right);
		tJ_1 = positionForMaximum(j-1,k,pos[maxNumber][mi-1],right);
		if (tJ == l){
			return maxNumber;
		}
		if (tJ_1 == l){
			return maxNumber;
		}
		if (tJ_1 < l && l < tJ) {
			li = ri = mi;
			break;
		} else if (l > tJ) {
			li = mi + 1;
		} else {
			ri = mi - 1;
		}
	}
	return G(pos[maxNumber][li-1]+1,pos[maxNumber][li]-1,tJ - tJ_1 - 1, l - tJ_1, maxNumber);
}

int main() {
	int m;
	int i,j;
	gets(s+1);
	n = strlen(s + 1);
	
	for (int i=1;i<=n;i++){
		pos[s[i]-'0'].push_back(i);
	}
	scanf("%d",&m);
	int k,l;
	while (m--) {
		scanf("%d%d",&k,&l);
		printf("%d",G(1,n,k,l,10));
	}
	return 0;
}